require 'redmine'

module TraceabilityMatrix
   
  ##############################################################################

  Redmine::WikiFormatting::Macros.register do
    desc "Traceability matrix between to list of issues"
         
               
    macro :traceability_matrix_short do |obj, args|
    
      ## Gestion des arguments ##      
      return 'Usage : {{traceability_matrix_short(query_row_id, query_col_id)}}' unless args.length == 2
      
      query_col_id = Query.find(args[0].strip)
      query_row_id = Query.find(args[1].strip)

      ## Execution du controlleur ##
      mt_ctrl = MtController.new  
      
      mt_ctrl.init_macro_context(@project)
      mt_ctrl.get_trackers(query_row_id, query_col_id)  
      mt_ctrl.build_list_of_issues
      
      disp = String.new
      disp << render(:partial => 'mt/mt_synthese', :locals => {:issue_cols => mt_ctrl.issue_cols, :tracker_cols => mt_ctrl.tracker_cols,
                     :issue_rows => mt_ctrl.issue_rows, :tracker_rows => mt_ctrl.tracker_rows, :issue_pairs => mt_ctrl.issue_pairs,
                     :not_seen_issue_cols => mt_ctrl.not_seen_issue_cols, :split_nb_cols => 20})
      
      return disp.html_safe

    end # Fin macro
    
    
    
    macro :traceability_matrix_detailed do |obj, args|
    
      ## Gestion des arguments ##      
      return 'Usage : {{traceability_matrix_short(query_row_id, query_col_id)}}' unless args.length == 2
      
      query_col_id = Query.find(args[0].strip)
      query_row_id = Query.find(args[1].strip)

      ## Execution du controlleur ##
      mt_ctrl = MtController.new  
      
      mt_ctrl.init_macro_context(@project)
      mt_ctrl.get_trackers(query_row_id, query_col_id)  
      mt_ctrl.build_list_of_issues
      
      disp = String.new
      disp << render(:partial => 'mt/mt_details', :locals => {:issue_cols => mt_ctrl.issue_cols, :tracker_cols => mt_ctrl.tracker_cols,
                     :issue_rows => mt_ctrl.issue_rows, :tracker_rows => mt_ctrl.tracker_rows, :issue_pairs => mt_ctrl.issue_pairs,
                     :not_seen_issue_cols => mt_ctrl.not_seen_issue_cols})
      
      return disp.html_safe

    end # Fin macro
    
    
    
    
    macro :test do |obj, args|
      disp = String.new
      
      @query = IssueQuery.find_by_id(args[0].strip)
      
      @issues = @query.issues();
      
      disp << @issues.lenght

      return disp.html_safe
      
    end # Fin macro
        
  end

end

################################################################################
